/* POWER MANAGEMENT USER ACTIVITY MONITOR MODULE
 * Copyright (C) 2001  Monta Vista Software Inc.
 *
 * /proc/interrupts cannot be used to accurately ascertain user input
 * activity due to the folly of mapping the usb controller to a shared
 * interrupt level.  This modules published the file /proc/pm_interrupts
 * containing device unique interrupt tallies for the usb-ohci and
 * mk712 devices.  Yes I know it is ugly.
 *
 *      Revision History
 *
 *      2001.01.25      Created.        john@mvista.com
 */

#define __KERNEL__
#define MODULE
#define __NO_VERSION__
#include <linux/module.h>
#include <linux/proc_fs.h>

#define PM_PROCFILENAME	"pm_interrupts"

char kernel_version[] = UTS_RELEASE;
extern int hc_interrupt_count;
extern int mk712_interrupt_count;
int pmproc_read(char *, char **, off_t, int, int *, void *);

int init_module(void)
	{
	struct proc_dir_entry *pde;

	if (pde = create_proc_entry(PM_PROCFILENAME, S_IFREG|S_IRUGO, &proc_root))
		pde->read_proc = &pmproc_read;
	return (0);
	}

void cleanup_module(void)
	{
	remove_proc_entry(PM_PROCFILENAME, &proc_root);
	}

int pmproc_read(char *page, char **start, off_t offset, int count, int *eof,
	void *data)
	{
	int len;

	len = sprintf(page, "usb-ohci %d\n" "mk712 %d\n",
		hc_interrupt_count, mk712_interrupt_count) - offset;
	if (len < 0)
		len = 0;
	else if (len <= count)
		*eof = 1;
	return (len);
	}
